'******************************
'*  VGA 640 x 480 x 8bpp-lut  *
'******************************

CON

  intensity     = 80 '0..128

  fclk          = 50_000_000.0
  fpix          = 25_000_000.0
  fset          = (fpix / fclk * 2.0) * float($4000_0000)

  vsync                =       57      'vsync pin, Prop123_A7 board
' vsync          =       0       'vsync pin, DE0-Nano and DE2-115 boards

DAT             org
'
'
' Setup
'
                rdfast  #0,##$1000-$40          'load .bmp palette into lut
                rep     @.end,#$100
                rflong  y
                shl     y,#8
                wrlut   y,x
                add     x,#1
.end
                wrlut   #0,#1
                wrlut   ##$FFFF_FF00,#0
'reorder bits
		mov	t,##$1000
		rep	@ReorderDone,##640*480/8
		rdbyte	y,t
		rev	x,y
		ror	x,#24
		wrbyte  x,t
		add	t,#1
ReorderDone
		

                rdfast  ##640*480/64/8,##$1000  'set rdfast to wrap on bitmap

                setxfrq ##round(fset)           'set transfer frequency to 25MHz

                setb    dira+vsync>>5,#vsync    'make vsync pin output

                setcy   ##intensity << 24       'r      set colorspace for rgb
                setci   ##intensity << 16       'g
                setcq   ##intensity << 08       'b

                setcmod #%01_0_000_0            'enable colorspace conversion (may be commented out)
                setcmod #%01_0_100_0            'enable colorspace conversion (may be commented out)

'
'
' Field loop
'
field           mov     x,#33                   'top blanks
                call    #blank

                mov     x,#480                  'set visible lines
line            call    #hsync                  'do horizontal sync
                xcont   m_rf,#0                 'visible line
                djnz    x,#line                 'another line?

                mov     x,#10                   'bottom blanks
                call    #blank

                notb    outa+vsync>>5,#vsync    'sync on

                mov     x,#2                    'sync blanks
                call    #blank

                notb    outa+vsync>>5,#vsync    'sync off

                jmp     #field                  'loop
'
'
' Subroutines
'
blank           call    #hsync                  'blank lines
                xcont   m_vi,#0
                djnz    x,#blank
                ret

hsync           xcont   m_bs,#0                 'horizontal sync
                xcont   m_sn,#1
                xcont   m_bv,#0
                ret
'
'
' Initialized data
'
m_bs            long    $CF000000+16            'before sync
m_sn            long    $CF000000+96            'sync
m_bv            long    $CF000000+48            'before visible
m_vi            long    $CF000000+640           'visible

'm_rf           long    $7F000000+640           'visible rlong 8bpp lut
'm_rf           long    $6F000000+640           'visible rlong 4bpp lut
m_rf            long    $4F000000+640           'visible rlong 1bpp lut

x               res     1
y               res     1
t		res 	1

'
' Bitmap
'
                orgh    $1000 - $3e     'justify pixels at $1000, pallete at $1000-$400
                file    "bitmap2_mono.bmp"